package edu.sc.seis.cormorant.redirect;

import java.util.Properties;
import org.omg.CORBA.ORB;
import org.omg.PortableServer.Servant;
import edu.sc.seis.cormorant.AbstractController;
import edu.sc.seis.cormorant.network.NetworkDCImpl;
import edu.sc.seis.fissuresUtil.namingService.FissuresNamingService;

public class RedirectController extends AbstractController {

    public RedirectController(Properties props, String serverName, ORB orb) {
        super(props, serverName, orb);
        finder = new RedirectingNetworkFinder(props, serverName);
        this.servant = new NetworkDCImpl(null, finder._this(orb));
    }

    public Servant getServant() {
        return servant;
    }

    public void start(ORB orb, FissuresNamingService ns) throws Exception {
        finder.start(ns);
        super.start(orb, ns);
    }

    public void stop(ORB orb, FissuresNamingService ns) throws Exception {
        super.stop(orb, ns);
        finder.clear();
    }

    private NetworkDCImpl servant;

    private RedirectingNetworkFinder finder;
}
